using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Sanford.Multimedia.Midi;

namespace MIDI2ASQ.Forms
{
    public partial class Analyse : Form
    {
        ASQWriter wr;
        Sequencer seq;
        public Analyse()
        {
            InitializeComponent();
        }

        private void Analyse_Load(object sender, EventArgs e)
        {
            ((Form1)Parent).buttonback.Enabled = ((Form1)Parent).buttonnext.Enabled = false;
            Sequence midi = new Sequence(((Form1)Parent).filename);
            seq = new Sequencer();
            seq.Sequence = midi;
            seq.SysExMessagePlayed += new EventHandler<SysExMessageEventArgs>(seq_SysExMessagePlayed);
            seq.ChannelMessagePlayed += new EventHandler<ChannelMessageEventArgs>(seq_ChannelMessagePlayed);
            seq.PlayingCompleted += new EventHandler(seq_PlayingCompleted);
            wr = new ASQWriter();
            progressBar1.Maximum = midi.GetLength();
            timer1.Start();
            wr.Start();
            seq.Start();
        }

        void seq_PlayingCompleted(object sender, EventArgs e)
        {
            timer1.Stop();
            textBox1_DoubleClick(null, null);
        }

        private void seq_ChannelMessagePlayed(object sender, ChannelMessageEventArgs e)
        {
            /*if (textBox1.InvokeRequired)
            {
                textBox1.Invoke(new EventHandler<ChannelMessageEventArgs>(seq_ChannelMessagePlayed), new object[] { sender, e });
                return;
            }
            textBox1.Text += e.Message.Command.ToString() + " {" + e.Message.MidiChannel + ": " + e.Message.Data1 + ", " + e.Message.Data2 + "}\r\n";
           */
            switch (e.Message.Command)
            {
                case ChannelCommand.NoteOn:
                    wr.NoteOn(e.Message.Data1, e.Message.MidiChannel);
                    break;
                case ChannelCommand.NoteOff:
                    wr.NoteOff(e.Message.Data1, e.Message.MidiChannel);
                    break;
            }
        }

        private void seq_SysExMessagePlayed(object sender, SysExMessageEventArgs e)
        {
            
        }

        private void textBox1_Click(object sender, EventArgs e)
        {
            
        }

        private void textBox1_DoubleClick(object sender, EventArgs e)
        {
            if (textBox1.InvokeRequired)
            {
                textBox1.Invoke(new EventHandler<ChannelMessageEventArgs>(seq_ChannelMessagePlayed), new object[] { null, null });
                return;
            }
            if (wr != null)
                textBox1.Text = wr.GetCode();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            progressBar1.Value = seq.Position;
        }
    }
}